/*
 * GLX Hardware Device Driver for Intel i810
 * Copyright (C) 1999 Keith Whitwell
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * KEITH WHITWELL, OR ANY OTHER CONTRIBUTORS BE LIABLE FOR ANY CLAIM, 
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR 
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE 
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 */

/* $Id: i810dd.h,v 1.1 1999/12/13 12:47:44 keithw Exp $ */

#ifndef I810DD_INC
#define I810DD_INC

#include "mesaglx/context.h"

#include "i810buf.h"

void i810_setup_DD_pointers( GLcontext *ctx );
void i810DDRegisterVB( struct vertex_buffer *VB );

void i810DDFastPath( struct vertex_buffer *VB );
void i810DDImmediateFastPath( struct vertex_buffer *VB );
void i810DDFastPathInit();
void i810DDExtensionsInit( GLcontext *ctx );

void i810_setup_DD_pointers_no_accel( GLcontext *ctx );
/*  void i810FinishPrimitive( void ); */

#define i810FinishPrimitive()



#endif
