/*
 * GLX Hardware Device Driver for S3 Savage3D and probably Savage/MX and
 * Savage/IX
 * Copyright (C) 2000 Dominik Behr
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * WITTAWAT YAMWONG, OR ANY OTHER CONTRIBUTORS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
 * OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 * Based on S3 Virge driver by Jim Duchek <jimduchek@ou.edu>
 *
 * Dominik Behr <behr@promail.pl>
 * thanks to Raja Koduri and Tim Roberts   
 */

#include "s3savglx.h"
#include <stdio.h>
#include <math.h>

#ifdef DUPLICATE_LAST_VERTEX
#define SEND_VERTICES 5L
#else
#define SEND_VERTICES 4L
#endif

/******************************************************************************

******************************************************************************/
void
s3savLine_TX(GLcontext *pCtx, 
             GLuint e0, 
             GLuint e1, 
             GLuint pv)
{ 
 float aVec[2];
 float fLen;
 const struct vertex_buffer *pVB;
 hwUI8 (*pColors)[4];		
 pVB = pCtx->VB;
 pColors = pVB->Color[0]->data;
 
 aVec[0] = pVB->Win.data[e1][1] - pVB->Win.data[e0][1];
 aVec[1] = pVB->Win.data[e1][0] - pVB->Win.data[e0][0];
 // normalize
 fLen = aVec[0] * aVec[0]
      + aVec[1] * aVec[1];
 // fuck dots
 if (fLen == 0.0f)
    return;      
 fLen = pCtx->Line.Width * 0.5f / sqrt(fLen);    
 aVec[0] *= fLen;
 aVec[1] *= fLen;
 // have to disable backface culling !!!
 if (stS3Sav.stDRAWCTRL.uBCM != 1) 
    s3savFIFOWait(2+SEND_VERTICES*8+4);
 else
    s3savFIFOWait(2+SEND_VERTICES*8);
 BCIRST;
 if (stS3Sav.stDRAWCTRL.uBCM != 1) 
    {
     S3SAVDRAWCTRL stDC = stS3Sav.stDRAWCTRL;
     stDC.uBCM = 1;
     BCISETREG(BCI_DRAWCTRL, DW(stDC));
    }
 BCIWR(BCI_CMD_TRIFAN | (SEND_VERTICES << 16));
 
 BCIWF(pVB->Win.data[e0][0] - aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e0][1] - aVec[1]));
 BCIWF(pVB->Win.data[e0][2] / 65535.0f);
 BCIWF(pVB->Win.data[e0][3]);
 BCIWR(S3SAVBGRA(pColors[e0][0], pColors[e0][1], pColors[e0][2], pColors[e0][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e0][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e0][1]);
 
 BCIWF(pVB->Win.data[e0][0] + aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e0][1] + aVec[1]));
 BCIWF(pVB->Win.data[e0][2] / 65535.0f);
 BCIWF(pVB->Win.data[e0][3]);
 BCIWR(S3SAVBGRA(pColors[e0][0], pColors[e0][1], pColors[e0][2], pColors[e0][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e0][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e0][1]);
 
 BCIWF(pVB->Win.data[e1][0] + aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e1][1] + aVec[1]));
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e1][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e1][1]);
  
 BCIWF(pVB->Win.data[e1][0] - aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e1][1] - aVec[1]));
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e1][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e1][1]);

 #ifdef DUPLICATE_LAST_VERTEX
 BCIWF(pVB->Win.data[e1][0] - aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e1][1] - aVec[1]));
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e1][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e1][1]);
 #endif

 // restore previous culling mode 
 if (stS3Sav.stDRAWCTRL.uBCM != 1) 
    BCISETREG(BCI_DRAWCTRL, DW(stS3Sav.stDRAWCTRL));
}

/******************************************************************************

******************************************************************************/
void
s3savLine_NT(GLcontext *pCtx, 
             GLuint e0, 
             GLuint e1, 
             GLuint pv)
{   
 float aVec[2];
 float fLen;
 const struct vertex_buffer *pVB;
 hwUI8 (*pColors)[4];		
 pVB = pCtx->VB;
 pColors = pVB->Color[0]->data;
 
 aVec[0] = pVB->Win.data[e1][1] - pVB->Win.data[e0][1];
 aVec[1] = pVB->Win.data[e1][0] - pVB->Win.data[e0][0];
 // normalize
 fLen = aVec[0] * aVec[0]
      + aVec[1] * aVec[1];
 // fuck dots
 if (fLen == 0.0f)
    return;      
 fLen = pCtx->Line.Width * 0.5f / sqrt(fLen);    
 aVec[0] *= fLen;
 aVec[1] *= fLen;
 // have to disable backface culling !!!
 if (stS3Sav.stDRAWCTRL.uBCM != 1) 
    s3savFIFOWait(2+SEND_VERTICES*6+4);
 else
    s3savFIFOWait(2+SEND_VERTICES*6);
 BCIRST;
 if (stS3Sav.stDRAWCTRL.uBCM != 1) 
    {
     S3SAVDRAWCTRL stDC = stS3Sav.stDRAWCTRL;
     stDC.uBCM = 1;
     BCISETREG(BCI_DRAWCTRL, DW(stDC));
    }
 BCIWR(BCI_CMD_TRIFAN | (SEND_VERTICES << 16) | BCI_SKIP_U | BCI_SKIP_V);
 
 BCIWF(pVB->Win.data[e0][0] - aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e0][1] - aVec[1]));
 BCIWF(pVB->Win.data[e0][2] / 65535.0f);
 BCIWF(pVB->Win.data[e0][3]);
 BCIWR(S3SAVBGRA(pColors[e0][0], pColors[e0][1], pColors[e0][2], pColors[e0][3]));
 BCIWR(0xFFFFFFFF); // s
 
 BCIWF(pVB->Win.data[e0][0] + aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e0][1] + aVec[1]));
 BCIWF(pVB->Win.data[e0][2] / 65535.0f);
 BCIWF(pVB->Win.data[e0][3]);
 BCIWR(S3SAVBGRA(pColors[e0][0], pColors[e0][1], pColors[e0][2], pColors[e0][3]));
 BCIWR(0xFFFFFFFF); // s
 
 BCIWF(pVB->Win.data[e1][0] + aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e1][1] + aVec[1]));
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s
  
 BCIWF(pVB->Win.data[e1][0] - aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e1][1] - aVec[1]));
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s

 #ifdef DUPLICATE_LAST_VERTEX
 BCIWF(pVB->Win.data[e1][0] - aVec[0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-(pVB->Win.data[e1][1] - aVec[1]));
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s
 #endif

 // restore previous culling mode 
 if (stS3Sav.stDRAWCTRL.uBCM != 1) 
    BCISETREG(BCI_DRAWCTRL, DW(stS3Sav.stDRAWCTRL));
}	  

#undef SEND_VERTICES
#ifdef DUPLICATE_LAST_VERTEX
#define SEND_VERTICES 4L
#else
#define SEND_VERTICES 3L
#endif


/******************************************************************************

******************************************************************************/
void 
s3savTriangle_TX(GLcontext *pCtx, 
                 GLuint e0, 
                 GLuint e1, 
                 GLuint e2, 
                 GLuint pv)
{
 const struct vertex_buffer *pVB;
 hwUI8 (*pColors)[4];		
 pVB = pCtx->VB;
 pColors = pVB->Color[0]->data;
 s3savFIFOWait(2+SEND_VERTICES*8);

 BCIRST;
 BCIWR(BCI_CMD_TRILIST | (SEND_VERTICES << 16));
 BCIWF(pVB->Win.data[e0][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e0][1]);
 BCIWF(pVB->Win.data[e0][2] / 65535.0f);
 BCIWF(pVB->Win.data[e0][3]);
 BCIWR(S3SAVBGRA(pColors[e0][0], pColors[e0][1], pColors[e0][2], pColors[e0][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e0][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e0][1]); 
 
 BCIWF(pVB->Win.data[e1][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e1][1]);
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e1][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e1][1]);
 
 BCIWF(pVB->Win.data[e2][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e2][1]);
 BCIWF(pVB->Win.data[e2][2] / 65535.0f);
 BCIWF(pVB->Win.data[e2][3]);
 BCIWR(S3SAVBGRA(pColors[e2][0], pColors[e2][1], pColors[e2][2], pColors[e2][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e2][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e2][1]);
 
 #ifdef DUPLICATE_LAST_VERTEX
 BCIWF(pVB->Win.data[e2][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e2][1]);
 BCIWF(pVB->Win.data[e2][2] / 65535.0f);
 BCIWF(pVB->Win.data[e2][3]);
 BCIWR(S3SAVBGRA(pColors[e2][0], pColors[e2][1], pColors[e2][2], pColors[e2][3]));
 BCIWR(0xFFFFFFFF); // s
 BCIWF(pVB->TexCoordPtr[0]->data[e2][0]);
 BCIWF(pVB->TexCoordPtr[0]->data[e2][1]);
 #endif
}

/******************************************************************************

******************************************************************************/
void 
s3savTriangle_NT(GLcontext *pCtx, 
                 GLuint e0, 
                 GLuint e1, 
                 GLuint e2, 
                 GLuint pv)
{
 const struct vertex_buffer *pVB;
 hwUI8 (*pColors)[4];		
 pVB = pCtx->VB;
 pColors = pVB->Color[0]->data;
 s3savFIFOWait(2+SEND_VERTICES*6);
 
 BCIRST;
 BCIWR(BCI_CMD_TRILIST | (SEND_VERTICES << 16) | BCI_SKIP_U | BCI_SKIP_V);
 BCIWF(pVB->Win.data[e0][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e0][1]);
 BCIWF(pVB->Win.data[e0][2] / 65535.0f);
 BCIWF(pVB->Win.data[e0][3]);
 BCIWR(S3SAVBGRA(pColors[e0][0], pColors[e0][1], pColors[e0][2], pColors[e0][3]));
 BCIWR(0xFFFFFFFF); // s
 
 BCIWF(pVB->Win.data[e1][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e1][1]);
 BCIWF(pVB->Win.data[e1][2] / 65535.0f);
 BCIWF(pVB->Win.data[e1][3]);
 BCIWR(S3SAVBGRA(pColors[e1][0], pColors[e1][1], pColors[e1][2], pColors[e1][3]));
 BCIWR(0xFFFFFFFF); // s
 
 BCIWF(pVB->Win.data[e2][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e2][1]);
 BCIWF(pVB->Win.data[e2][2] / 65535.0f);
 BCIWF(pVB->Win.data[e2][3]);
 BCIWR(S3SAVBGRA(pColors[e2][0], pColors[e2][1], pColors[e2][2], pColors[e2][3]));
 BCIWR(0xFFFFFFFF); // s
 
 #ifdef DUPLICATE_LAST_VERTEX
 BCIWF(pVB->Win.data[e2][0]);
 BCIWF(stS3Sav.pContext->fViewportHeight-pVB->Win.data[e2][1]);
 BCIWF(pVB->Win.data[e2][2] / 65535.0f);
 BCIWF(pVB->Win.data[e2][3]);
 BCIWR(S3SAVBGRA(pColors[e2][0], pColors[e2][1], pColors[e2][2], pColors[e2][3]));
 BCIWR(0xFFFFFFFF); // s
 #endif
}

#undef SEND_VERTICES
