
/*
 * GLX Server Extension
 * Copyright (C) 1998, 1999 Terence Ripperda (ripperda@sgi.com)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * TERENCE RIPPERDA, OR ANY OTHER CONTRIBUTORS BE LIABLE FOR ANY CLAIM, DAMAGES
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, 
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 * DEALINGS IN THE SOFTWARE.
 */

#include "glx_dispatch.h"
#include "glxcmds.h"

/* Lots of trailing entries to avoid sanity check in ServerMesaDispatch,
 * 256 entries in all */

__glx_dispatch_proc __glx_dispatch_table[] = {
   GLnoop,
   GLRender,
   GLRenderLarge,
   GLCreateContext,
   GLDestroyContext,          
   GLMakeCurrent,
   GLIsDirect,
   GLQueryVersion,
   GLWaitGL,
   GLWaitX,
   GLCopyContext,
   GLSwapBuffers,
   GLUseXFont,
   GLCreateGLXPixmap,
   GLGetVisualConfigs,
   GLDestroyGLXPixmap,
   GLVendorPrivate,
   GLVendorPrivateWithReply,
   GLnoop,
   GLQueryServerString,
   GLClientInfo,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLNewList,
   GLEndList,
   GLDeleteLists,
   GLGenLists,
   GLFeedbackBuffer,
   GLSelectBuffer,
   GLRenderMode,
   GLFinish,
   GLPixelStoref,
   GLPixelStorei,
   GLReadPixels,
   GLGetBooleanv,
   GLGetClipPlane,
   GLGetDoublev,
   GLGetError,
   GLGetFloatv,
   GLGetIntegerv,
   GLGetLightfv,
   GLGetLightiv,
   GLGetMapdv,
   GLGetMapfv,
   GLGetMapiv,
   GLGetMaterialfv,
   GLGetMaterialiv,
   GLGetPixelMapfv,
   GLGetPixelMapuiv,
   GLGetPixelMapusv,
   GLGetPolygonStipple,
   GLGetString,
   GLGetTexEnvfv,
   GLGetTexEnviv,
   GLGetTexGendv,
   GLGetTexGenfv,
   GLGetTexGeniv,
   GLGetTexImage,
   GLGetTexParameterfv,
   GLGetTexParameteriv,
   GLGetTexLevelParameterfv,
   GLGetTexLevelParameteriv,
   GLIsEnabled,
   GLIsList,
   GLFlush,
   GLAreTexturesResident,
   GLDeleteTextures,
   GLGenTextures,
   GLIsTexture,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop,
   GLnoop
};
